#include "descriptor/descriptor.h"

int main(void) {
  ITEM	materiale_cassa,materiale2,attr,attr2,verde,alluminio,nero_opaco,brown,nero,bronze,silver, 					lampada;
  ITEM	scena,stanza,chitarra,cassa,muri,pavimento,manico,battipenna,corde2,corde4,chiavi,capotasti, 				tastiera,cerchiocassa,fermacorde,fermacorde_base,piedistallo,piedistallo_sostegno1, 							piedistallo_sostegno2,lampadina,lampadina2,lampadina3,fari,faro1,faro2,faro3,faroa,farob,faroc;

  set_background(0,0.15,0.15,TRUE);
  set_ambient_light(1,1,1,1);
  create_warn_light(2.849,4.782,4.815, -0.380,-0.701,-0.602, 1,1,1, 1.3,20, 5, 29, 0,0,0,0,0, 											"warn_light");
  create_warn_light(2.849,-4.782,4.815, -0.380,0.701,-0.602, 1,1,1, 1.3,20, 5, 29, 0,0,0,0,0, 											"warn_light2");
  create_warn_light(-2.308,0,4.458, 0.565,0,-0.824, 1,1,1, 1,10, 5, 20, 0,0,0,0,0, "warn_light3");

  materiale_cassa=create_attribute("materiale_cassa");
  set_color(materiale_cassa,0.896,0,0,0.2,0.75);
  set_reflectivity(materiale_cassa,0.15,15);

  nero_opaco = create_attribute("nero_opaco");
  set_color(nero_opaco,0.05,0.05,0.05,0.2,0.8);
  set_reflectivity(nero_opaco,0.01,2);

  brown = create_attribute("brown");
  set_color(brown,0.32,0.072,0,0.2,0.8);
  set_reflectivity(brown,0.03,2);

  alluminio = create_attribute("alluminio");
  set_color(alluminio,0.63,0.63,0.69,0.1,0.2);
  set_reflectivity(alluminio,0.55,2);

  bronze = create_attribute("bronze");
  set_color(bronze,0.96,0.82,0,0.2,0.6);
  set_reflectivity(bronze,0.20,2);

  silver = create_attribute("silver");
  set_color(silver,0.63,0.63,0.69,0.2,0.7);
  set_reflectivity(silver,0.25,2);

  verde = create_attribute("verde");
  set_color(verde,0, 0.5, 0.5, 0.1, 0.7);
  set_reflectivity(verde, 0.07, 2);

  nero = create_attribute("nero");
  set_color(nero,0.05, 0.05, 0.05, 0.1, 0.7);
  set_reflectivity(nero, 0.4, 20);

  lampada = create_attribute("lampada");
  set_color(lampada,1, 1, 0.88, 1, 1);
  set_reflectivity(lampada, 0.7, 20);

  /***************** Stanza ***********************/
  stanza=read_nurbs("pavimento.db");
  set_projection_texture(stanza,materiale_cassa,"textures/wood1.hr",2,TRUE,0.2,0.8);
  scena=create_list(stanza, "scena");

  muri=read_obj("muri.obj","muri");
  set_attribute(muri,verde);
  scena=insert_in_list(scena, muri);

  /***************** Chitarra ***********************/
  cassa=read_nurbs("cassa.dbe");
  set_attribute(cassa,materiale_cassa);
  chitarra=create_list(cassa, "chitarra");

  cerchiocassa=read_nurbs("cerchiocassa.db");
  set_attribute(cerchiocassa,brown);
  set_scale(cerchiocassa,1,1,0.98);
  chitarra = insert_in_list(chitarra, cerchiocassa);

  manico=read_obj("manico.obj","manico");
  set_attribute(manico,materiale_cassa);
  chitarra = insert_in_list(chitarra, manico);

  tastiera=read_nurbs("tastiera2.db");
  set_attribute(tastiera,brown);
  set_translate(tastiera,-0.004,0,0);
  chitarra = insert_in_list(chitarra, tastiera);

  corde4=read_obj("corde4.obj","corde4");
  set_attribute(corde4,bronze);
  chitarra = insert_in_list(chitarra, corde4);

  corde2=read_obj("corde2.obj","corde2");
  set_attribute(corde2,silver);
  chitarra = insert_in_list(chitarra, corde2);

  battipenna=read_nurbs("battipenna.db");
  set_projection_texture(battipenna,materiale_cassa,"textures/red.hr",0,TRUE,0.4,0.1);
  chitarra = insert_in_list(chitarra, battipenna);

  capotasti=read_obj("capotasti.obj","capotasti");
  set_attribute(capotasti,alluminio);
  set_translate(capotasti,-0.004,0,0);
  chitarra = insert_in_list(chitarra, capotasti);

  chiavi=read_obj("chiavi.obj","chiavi");
  set_attribute(chiavi,alluminio);
  chitarra = insert_in_list(chitarra, chiavi);

  fermacorde=read_obj("fermacorde.obj","fermacorde");
  set_attribute(fermacorde,alluminio);
  chitarra = insert_in_list(chitarra, fermacorde);

  fermacorde_base=read_nurbs("fermacorde.db");
  set_attribute(fermacorde_base,brown);
  chitarra = insert_in_list(chitarra, fermacorde_base);
  set_y_rotate(chitarra,-20,1);
  set_translate(chitarra,0.035,0,-0.09);
  scena = insert_in_list(scena, chitarra);

  /***************** Piedistallo ***********************/
  piedistallo=read_obj("piedistallo.obj","piedistallo_struttura");
  set_projection_texture(piedistallo,nero,"textures/black.hr",2,TRUE,0.2,0.8);
  piedistallo = create_list(piedistallo,"piedistallo");

  piedistallo_sostegno1=read_nurbs("piedistallo5.db");
  set_attribute(piedistallo_sostegno1,nero_opaco);
  piedistallo = insert_in_list(piedistallo, piedistallo_sostegno1);

  piedistallo_sostegno2=read_nurbs("piedistallo6.db");
  set_attribute(piedistallo_sostegno2,nero_opaco);
  piedistallo = insert_in_list(piedistallo, piedistallo_sostegno2);

  scena = insert_in_list(scena, piedistallo);

   /***************** Fari ***********************/
  faroa=read_obj("faro1.obj","faro sinistro");
  set_projection_texture(faroa,nero,"textures/grey.hr",2,TRUE,0.4,0.6);
  faro1=create_list(faroa, "faro1");

  lampadina=read_nurbs("lampadina.db");
  set_attribute(lampadina,lampada);
  faro1 = insert_in_list(faro1, lampadina);

  scena = insert_in_list(scena, faro1);

  farob=read_obj("faro2.obj","faro destro");
  set_projection_texture(farob,nero,"textures/grey.hr",2,TRUE,0.4,0.6);
  faro2=create_list(farob, "faro2");

  lampadina2=read_nurbs("lampadina2.db");
  set_attribute(lampadina2,lampada);
  faro2 = insert_in_list(faro2, lampadina2);

  scena = insert_in_list(scena, faro2);

  faroc=read_obj("faro3.obj","faro centrale");
  set_projection_texture(faroc,nero,"textures/grey.hr",2,TRUE,0.4,0.6);
  faro3=create_list(faroc, "faro3");

  lampadina3=read_nurbs("lampadina3.db");
  set_attribute(lampadina3,lampada);
  faro3 = insert_in_list(faro3, lampadina3);

  scena = insert_in_list(scena, faro3);


  save_scene("scena.md", "scena", scena);
  return(0);

}

